#
# Please send bugfixes or comments to
# 	http://www.rtems.org/bugzilla
#

%define _prefix                 /opt/rtems-4.11
%define _exec_prefix            %{_prefix}
%define _bindir                 %{_exec_prefix}/bin
%define _sbindir                %{_exec_prefix}/sbin
%define _libexecdir             %{_exec_prefix}/libexec
%define _datarootdir            %{_prefix}/share
%define _datadir                %{_datarootdir}
%define _sysconfdir             %{_prefix}/etc
%define _sharedstatedir         %{_prefix}/com
%define _localstatedir          %{_prefix}/var
%define _includedir             %{_prefix}/include
%define _libdir                 %{_exec_prefix}/%{_lib}
%define _mandir                 %{_datarootdir}/man
%define _infodir                %{_datarootdir}/info
%define _localedir              %{_datarootdir}/locale

%ifos cygwin cygwin32 mingw mingw32
%define _exeext .exe
%define debug_package           %{nil}
%define _libdir                 %{_exec_prefix}/lib
%else
%define _exeext %{nil}
%endif

%ifos cygwin cygwin32
%define optflags -O3 -pipe -march=i486 -funroll-loops
%endif

%ifos mingw mingw32
%if %{defined _mingw32_cflags}
%define optflags %{_mingw32_cflags}
%else
%define optflags -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions --param=ssp-buffer-size=4 -mms-bitfields
%endif
%endif

%if "%{_build}" != "%{_host}"
%define _host_rpmprefix %{_host}-
%else
%define _host_rpmprefix %{nil}
%endif

%define freebsd_version 9.0
%define freebsd_rpmvers %{expand:%(echo 9.0 | tr - _)}

%define _use_internal_dependency_generator 0
%define __debug_install_post %{nil}

Name:		rtems-4.11-i586-pc-freebsd9.0
Release:	0.20120112.0%{?dist}
License:	FreeBSD
Group:		Development/Tools

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch

Version:      	%freebsd_rpmvers
Summary:      	i586-pc-freebsd9.0 Libraries

Source0:  ftp://ftp.freebsd.org/pub/FreeBSD/releases/i386/9.0-RELEASE/base.txz

%description
i586-pc-freebsd9.0 libraries.

%prep
%setup -c -T -n %{name}-%{version}
%setup -T -D -n %{name}-%{version} -a0 

%build
  # Setup sys-root (Usable for gcc >= 3.4)
  mkdir -p i586-pc-freebsd9.0/sys-root
  %{__tar} cf - lib usr/lib usr/include | ( cd i586-pc-freebsd9.0/sys-root ; %{__tar} xf -)

  pushd i586-pc-freebsd9.0/sys-root/usr/lib > /dev/null
  # missing files
  rm -f lib*_p.*
  # not needed
  rm -rf aout compat

  # Fix up symlinks
  find -type l -exec ls -l {} \; | \
    while read a0 a1 a2 a3 a4 a5 a6 a7 a8 a9 aA ; do \
    case $aA in
    /lib* ) # link
       rm $a8;
       b=`basename $aA`
       ln -s ../../lib/$b $a8
       ;;
    esac
  done
  popd > /dev/null

%install
  rm -rf $RPM_BUILD_ROOT
  mkdir -p $RPM_BUILD_ROOT%{_prefix}
  cp -a i586-pc-freebsd9.0 $RPM_BUILD_ROOT%{_prefix}

# Extract %%__os_install_post into os_install_post~
cat << \EOF > os_install_post~
%__os_install_post
EOF

# Generate customized brp-*scripts
cat os_install_post~ | while read a x y; do
case $a in
# Prevent brp-strip* from trying to handle foreign binaries
*/brp-strip*)
  b=$(basename $a)
  sed -e 's,find $RPM_BUILD_ROOT,find $RPM_BUILD_ROOT%_bindir $RPM_BUILD_ROOT%_libexecdir,' $a > $b
  chmod a+x $b
  ;;
# Fix up brp-compress to handle %%_prefix != /usr
*/brp-compress*)
  b=$(basename $a)
  sed -e 's,\./usr/,.%{_prefix}/,g' < $a > $b
  chmod a+x $b
  ;;
esac
done

sed -e 's,^[ ]*/usr/lib/rpm.*/brp-strip,./brp-strip,' \
  -e 's,^[ ]*/usr/lib/rpm.*/brp-compress,./brp-compress,' \
< os_install_post~ > os_install_post 
%define __os_install_post . ./os_install_post


cat << EOF > %{_builddir}/%{name}-%{freebsd_rpmvers}/find-provides
#!/bin/sh
grep -E -v '^${RPM_BUILD_ROOT}%{_exec_prefix}/i586-pc-freebsd9.0/(lib|include|sys-root)' \
  %{?_gcclibdir:| grep -v '^${RPM_BUILD_ROOT}%{_gcclibdir}/gcc/i586-pc-freebsd9.0/'} | %__find_provides
EOF
chmod +x %{_builddir}/%{name}-%{freebsd_rpmvers}/find-provides
%define __find_provides %{_builddir}/%{name}-%{freebsd_rpmvers}/find-provides

cat << EOF > %{_builddir}/%{name}-%{freebsd_rpmvers}/find-requires
#!/bin/sh
grep -E -v '^${RPM_BUILD_ROOT}%{_exec_prefix}/i586-pc-freebsd9.0/(lib|include|sys-root)' \
  %{?_gcclibdir:| grep -v '^${RPM_BUILD_ROOT}%{_gcclibdir}/gcc/i586-pc-freebsd9.0/'} | %__find_requires
EOF
chmod +x %{_builddir}/%{name}-%{freebsd_rpmvers}/find-requires
%define __find_requires %{_builddir}/%{name}-%{freebsd_rpmvers}/find-requires

%ifnarch noarch
# Extract %%__debug_install_post into debug_install_post~
cat << \EOF > debug_install_post~
%__debug_install_post
EOF

# Generate customized debug_install_post script
cat debug_install_post~ | while read a x y; do
case $a in
# Prevent find-debuginfo.sh* from trying to handle foreign binaries
*/find-debuginfo.sh)
  b=$(basename $a)
  sed -e 's,find "$RPM_BUILD_ROOT" !,find "$RPM_BUILD_ROOT"%_bindir "$RPM_BUILD_ROOT"%_libexecdir !,' $a > $b
  chmod a+x $b
  ;;
esac
done

sed -e 's,^[ ]*/usr/lib/rpm/find-debuginfo.sh,./find-debuginfo.sh,' \
< debug_install_post~ > debug_install_post 
%define __debug_install_post . ./debug_install_post

%endif

%clean
  rm -rf $RPM_BUILD_ROOT

%package sys-root
Group: Development/Tools
Summary: i586-pc-freebsd9.0 target files for gcc >= 3.4

%description sys-root
i586-pc-freebsd9.0 target files for gcc >= 3.4

%files sys-root
%defattr(-,root,root,-)
%dir %{_prefix}/i586-pc-freebsd9.0
%{_prefix}/i586-pc-freebsd9.0/sys-root
