#
# Please send bugfixes or comments to
# 	http://www.rtems.org/bugzilla
#

%?mingw_package_header

%define mpc_version 0.8.1
%define mpc_rpmvers %{expand:%(echo 0.8.1 | tr - _)} 

Name:         mingw-mpc
Release:      0.20120426.0%{?dist}
License:      GPL
Group:        Development/Tools

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch

Version:      	%mpc_rpmvers
Summary:      	MinGW mpc Libraries

Source0:	http://www.multiprecision.org/mpc/download/mpc-%{mpc_version}.tar.gz

BuildRequires:  mingw32-filesystem
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw32-gmp
BuildRequires:  mingw32-mpfr

%if 0%{?fedora} >= 17
BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  mingw64-gmp
BuildRequires:  mingw64-mpfr
%else
# Cludge to work around /usr/lib/rpm/brp-strip-static-archive corrupting *.a's
%global __strip	%{_mingw32_strip}
# F16 uses _mingw32_sysroot, fedora > 16 uses mingw32_sysroot
%global mingw32_sysroot %{_mingw32_sysroot}
%endif

BuildRequires:  m4

%description
%{summary}

%package	-n mingw32-mpc
Summary:	MinGW32 mpc libraries
Group:		Development/Tools

%description	-n mingw32-mpc
%{summary}

%if %{?mingw_build_win64}0
%package	-n mingw64-mpc
Summary:	MinGW64 mpc libraries
Group:		Development/Tools

%description	-n mingw64-mpc
%{summary}
%endif

%?mingw_debug_package

%prep
%setup -q -n mpc-%{mpc_version}

%build
%{?mingw_build_win64:%mingw_configure}%{!?mingw_build_win64:%_mingw32_configure} --enable-static --disable-shared

%{?mingw_build_win64:%mingw_make}%{!?mingw_build_win64:%_mingw32_make}

%install
%{?mingw_build_win64:%mingw_make_install}%{!?mingw_build_win64:make install} DESTDIR=$RPM_BUILD_ROOT


%files -n mingw32-mpc
%defattr(-,root,root,-)
%{mingw32_sysroot}/mingw
%exclude %{mingw32_sysroot}/mingw/share/info/dir

%if %{?mingw_build_win64}0
%files -n mingw64-mpc
%defattr(-,root,root,-)
%{mingw64_sysroot}/mingw
%exclude %{mingw64_sysroot}/mingw/share/info/dir
%endif
