#
# Please send bugfixes or comments to
# 	http://www.rtems.org/bugzilla
#

%?mingw_package_header

%define mpfr_version 2.4.2
%define mpfr_rpmvers %{expand:%(echo 2.4.2 | tr - _)} 

Name:         mingw-mpfr
Release:      0.20120426.0%{?dist}
License:      GPL
Group:        Development/Tools

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch

Version:      	%mpfr_rpmvers
Summary:      	MinGW mpfr Libraries

Source0:	http://www.mpfr.org/mpfr-%{mpfr_version}/mpfr-%{mpfr_version}.tar.%{?el5:bz2}%{!?el5:xz}

BuildRequires:  mingw32-filesystem
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw32-gmp

%if 0%{?fedora} >= 17
BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  mingw64-gmp
%else
# Cludge to work around /usr/lib/rpm/brp-strip-static-archive corrupting *.a's
%global __strip	%{_mingw32_strip}
# F16 uses _mingw32_sysroot, fedora > 16 uses mingw32_sysroot
%global mingw32_sysroot %{_mingw32_sysroot}
%endif

BuildRequires:  m4

%description
%{summary}

%package	-n mingw32-mpfr
Summary:	MinGW32 mpfr libraries
Group:        	Development/Tools

%description	-n mingw32-mpfr
%{summary}

%if %{?mingw_build_win64}0
%package	-n mingw64-mpfr
Summary:	MinGW64 mpfr libraries
Group:        	Development/Tools

%description	-n mingw64-mpfr
%{summary}
%endif

%?mingw_debug_package

%prep
%setup -q -n mpfr-%{mpfr_version}

%build
%{?mingw_build_win64:%mingw_configure}%{!?mingw_build_win64:%_mingw32_configure} --enable-static --disable-shared

%{?mingw_build_win64:%mingw_make}%{!?mingw_build_win64:%_mingw32_make}

%install
%{?mingw_build_win64:%mingw_make_install}%{!?mingw_build_win64:make install} DESTDIR=$RPM_BUILD_ROOT


%files -n mingw32-mpfr
%defattr(-,root,root,-)
%{mingw32_sysroot}/mingw
%exclude %{mingw32_sysroot}/mingw/share/info/dir

%if %{?mingw_build_win64}0
%files -n mingw64-mpfr
%defattr(-,root,root,-)
%{mingw64_sysroot}/mingw
%exclude %{mingw64_sysroot}/mingw/share/info/dir
%endif
